* This is a sample do file for the WinEdt Stata configuration
* Stata commands, options, macros, strings and comments should be highlighted
* The do file performs a simulation

// Press CTRL+D to invoke Stata in batch mode

version 6.0
capture program drop cnorm

program define cnorm
    version 6.0
    local N `2'     /* assigns the arguments in the call of sim_cnorm to local macro names */
    local mu `3'
    local sigma `4'
    local k `5'
    if "`1'" == "?" {
        global S_1 "mean sd" /* assigns variables to be output to global macro `S_1' */
        exit
    }
    drop _all
    set obs `N'
    generate u = uniform()
    generate y = (u<=`k')*10*uniform() + (u>`k')*(`mu'+`sigma'*invnorm(uniform()))
    summarize y,  detail
    post `1' (r(mean)) (r(sd)) /*adds observations (mean, standard deviation) to the dataset of simulated results*/
end

/* perform 100 simulations
with n=1000, mu=.15, sigma=1.2, k=.2 */
simul cnorm, reps(100) args(1000 .15 1.2 .2)
summarize

save estimates, replace
